using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;

namespace _40364
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(264, 368);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.10";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 390);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataSet dSet = new DataSet();
		private void Form1_Load(object sender, System.EventArgs e)
		{
			

			//get the tables
			DataTable orderTable = GetOrderTable();
			//			dSet.Tables.Add(parentTable);
			DataTable exchangeTable = GetExchangeTable();
			//			dSet.Tables.Add(childTable);
			dSet.Tables.AddRange(new DataTable[] {orderTable, exchangeTable});

			//setup the relations
			DataColumn orderColumn = orderTable.Columns["OrderID"];
			DataColumn exchangeColumn = exchangeTable.Columns["OrderID"];

			dSet.Relations.Add("ParentToChild", orderColumn, exchangeColumn);
			this.gridGroupingControl1.DataSource =orderTable; 
			this.gridGroupingControl1.TableControlMouseDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlMouseEventHandler(this.gridGroupingControl1_TableControlMouseDown);
			this.gridGroupingControl1.TableOptions.AllowSortColumns = false;

			

		}

		#region Table Generation
		private DataTable GetOrderTable()
		{
			DataTable dt = new DataTable("Orders");

			int nRows = 5;

			dt.Columns.Add(new DataColumn("OrderID"));
			dt.Columns.Add(new DataColumn("Qty"));
			dt.Columns.Add(new DataColumn("Price"));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i;
				dr[1] = i.ToString();
				dr[2] = (i*10).ToString();
				dt.Rows.Add(dr);
			}

			return dt;
		}
		private DataTable GetExchangeTable()
		{
			DataTable dt = new DataTable("Exchanges");

			dt.Columns.Add(new DataColumn("OrderID")); 
			dt.Columns.Add(new DataColumn("ExchangeID"));
			dt.Columns.Add(new DataColumn("Exchange"));
			
			for(int i = 0; i < 20; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = (i % 5);
				dr[1] = (i % 5)+2;
				dr[2] = string.Format("Exchange {0}",i);
				dt.Rows.Add(dr);
			}
		
			return dt;
		}
		#endregion



		private void gridGroupingControl1_TableControlMouseDown(object sender, GridTableControlMouseEventArgs e)
		{
			if(e.Inner.Button == MouseButtons.Middle)
			{
				int row, col;
				if(e.TableControl.PointToRowCol(new Point(e.Inner.X, e.Inner.Y), out row, out col, -1))
				{
					GridTableCellStyleInfo style = this.gridGroupingControl1.TableControl.PointToTableCellStyle(new Point(e.Inner.X, e.Inner.Y));
							
					if(style.TableCellIdentity.TableCellType == GridTableCellType.ColumnHeaderCell)
					{
						GridGroupingControl grid = sender as GridGroupingControl;
						Element el = grid.Table.DisplayElements[row];
						string name;
						if(el.Kind == DisplayElementKind.NestedTable)
						{
							GridNestedTable nt = (GridNestedTable) el;
							int target=grid.GetTable(nt.ChildTable.Name.ToString()).TableDescriptor.ColIndexToField(col-3);
							name=grid.GetTable(nt.ChildTable.Name.ToString()).TableDescriptor.Columns[target].Name;
						}

						else
						{
							int field = style.TableCellIdentity.Table.TableDescriptor.ColIndexToField(col);
							name = style.TableCellIdentity.Table.TableDescriptor.Columns[field].Name;
						}
						SortColumnDescriptor sd = style.TableCellIdentity.Table.TableDescriptor.SortedColumns[name];
						bool ctrlKeyPressed = style.TableCellIdentity.Table.TableDescriptor.TableOptions.AllowMultiColumnSort && (Control.ModifierKeys & Keys.Control) != 0; 
						if(sd != null)
						{
							if (sd.SortDirection == ListSortDirection.Ascending)
								sd.SortDirection = ListSortDirection.Descending;
							else
								sd.SortDirection = ListSortDirection.Ascending;
							if (!ctrlKeyPressed)
							{
								style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Clear();
								style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Add(sd);
							}
						}
						else
						{
							sd = style.TableCellIdentity.Table.TableDescriptor.SortedColumns[name];
							if (sd != null && (style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Count == 1 || ctrlKeyPressed))
							{
								if (sd.SortDirection == ListSortDirection.Ascending)
									sd.SortDirection = ListSortDirection.Descending;
								else
									sd.SortDirection = ListSortDirection.Ascending;
							}
							else if (ctrlKeyPressed)
							{
								style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Add(name);
							}
							else
							{
								style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Clear();
								style.TableCellIdentity.Table.TableDescriptor.SortedColumns.Add(name);
							}
						}
					}
				}
			}
		}

	}

}
